/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: mxcmpsofsc.m,v 1.7 92/06/29 18:16:49 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   int
 *   XMaxCmapsOfScreen(screen)
 *   Screen	*screen;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XMaxCmapsOfScreen	1
char    *TestName = "XMaxCmapsOfScreen";

/*
 * Defines for different argument types
 */


/*
 * Arguments to the XMaxCmapsOfScreen function
 */
static Screen	*screen;


static int 	ValueReturn;

int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	screen = DefaultScreenOfDisplay(Dsp);
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XMaxCmapsOfScreen-1.(B)
 *   Reason: There is no known reliable test method for this assertion
 * A call to XMaxCmapsOfScreen returns the maximum number of
 * installed colourmaps supported by the screen screen.
 */
static void
t001()
{
int		maxm;
int		minm;
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();

	minm = XMinCmapsOfScreen( screen );

	if (minm <= 0) {
		delete("XMinCmapsOfScreen() returned %d.", minm);
		return;
	} else
		CHECK;

	startcall(Dsp);
	if (isdeleted())
		return;
	maxm = XMaxCmapsOfScreen(screen);
	endcall(Dsp);
	if (geterr() != Success) {
		report("Got %s, Expecting Success", errorname(geterr()));
		FAIL;
	}

	if (maxm < minm) {
		report("%s() returns %d, but the minimum was %d",
			TestName, maxm, minm);
		FAIL;
	} else
		CHECK;

	CHECKUNTESTED(2);
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
