/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: vndrrls.m,v 1.6 92/06/11 16:02:08 rws Exp $
 */
>>SET   macro
>>TITLE XVendorRelease CH02
char *
XVendorRelease(display)
Display	*display = Dsp;
>>EXTERN
#include <string.h>
/*
 * extract fields from version
 */
#define GET_MAJOR(ver)	((ver) / 10000000)
#define GET_MINOR(ver)	(((ver) % 10000000) / 100000)
#define GET_PATCH(ver)	(((ver) % 100000) / 1000)
#define GET_SNAP(ver)	(((ver) % 1000))
#define EXTRACT_VERSION(name, ver) \
			ver_##name##_major = GET_MAJOR(ver); \
			ver_##name##_minor = GET_MINOR(ver); \
			ver_##name##_patch = GET_PATCH(ver); \
			ver_##name##_snap = GET_SNAP(ver)
#define SEPS	":"

>>ASSERTION Good B 1
A call to xname returns a number related to a vendor's release of the X server.
>>STRATEGY
Obtain the value of the vendor's X server release using xname.
>>CODE
int	vr, cfgvr;
int	ver_ret_major, ver_ret_minor, ver_ret_patch, ver_ret_snap;
int	ver_cfg_major, ver_cfg_minor, ver_cfg_patch, ver_cfg_snap;
Bool	matched = False;
char	*Prelease;
char	*tok;

	vr = XCALL;

	/* convert versions to fields  and then check with config.vendor_lease */
	EXTRACT_VERSION(ret, vr);

	Prelease = (char *)malloc(strlen(config.vendor_release) * sizeof(char));
	if (Prelease == (char *)NULL) {
		delete("Could not allocate memory for vendor release string");
		return;
	} else
		CHECK;

	strcpy(Prelease, config.vendor_release);
	while ((tok = strsep(&Prelease, SEPS)) != NULL) {
		cfgvr = atov(tok);
		EXTRACT_VERSION(cfg, cfgvr);

		if ((ver_ret_major == ver_cfg_major) &&
		    ((ver_ret_minor >= ver_cfg_minor) ||
		     (ver_ret_patch >= ver_cfg_patch) ||
		     (ver_ret_snap >= ver_cfg_snap))) {
			matched = True;
			break;
		} 
	}

	if (matched == False) {
		report("%s() returned %d instead one of %s.", TestName, vr, config.vendor_release);
		FAIL;
	} else
		CHECK;

	CHECKPASS(2);
