/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: vslidfrmvs.m,v 1.4 92/06/11 16:12:01 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   VisualID
 *   XVisualIDFromVisual(visual)
 *   Visual	*visual;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XVisualIDFromVisual	1
char    *TestName = "XVisualIDFromVisual";

/*
 * Defines for different argument types
 */


/*
 * Arguments to the XVisualIDFromVisual function
 */
static Visual	*visual;


int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	visual = 0;
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XVisualIDFromVisual-1.(A)
 * A call to XVisualIDFromVisual returns the visual ID for the
 * specified visual.
 */
static void
t001()
{
VisualID	vid;
XVisualInfo	*vp;
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();

	for (resetvinf(VI_WIN); nextvinf(&vp); ) {
		visual = vp->visual;

		startcall(Dsp);
		if (isdeleted())
			return;
		vid = XVisualIDFromVisual(visual);
		endcall(Dsp);
		if (geterr() != Success) {
			report("Got %s, Expecting Success", errorname(geterr()));
			FAIL;
		}
		trace("Returned visual id was %ld", (long)vid);

		/*
		 * VisualID is a 32 bit value with the top three bits 0
		 */
		if (vid & 0xe0000000) {
			report("Some of top three bits of VisualID were set");
			report("value was 0x%lx", vid);
			FAIL;
		} else {
			CHECK;
		}
	}
	CHECKPASS(nvinf());
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
