/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: allcclsshn.m,v 1.5 92/06/11 17:26:53 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   XClassHint *
 *   XAllocClassHint()
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XAllocClassHint	1
char    *TestName = "XAllocClassHint";



int 	tet_thistest;

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XAllocClassHint-1.(A)
 * A call to XAllocClassHint allocates and returns a pointer
 * to a XClassHint structure in which each component is set to
 * NULL.
 */
static void
t001()
{
XClassHint *chint;
int 	pass = 0, fail = 0;

	tpstartup();

	startcall(Dsp);
	if (isdeleted())
		return;
	chint = XAllocClassHint();
	endcall(Dsp);
	if (geterr() != Success) {
		report("Got %s, Expecting Success", errorname(geterr()));
		FAIL;
	}
	
	if(chint == (XClassHint *) NULL) {
		delete("XAllocClassHint() returned NULL.");
		return;
	} else
		CHECK;

	if(chint->res_name != NULL) {
		report("The res_name component of the XClassHints structure was not NULL.");
		FAIL;
	} else
		CHECK;

	if(chint->res_class != NULL) {
		report("The res_class component of the XClassHints structure was not NULL.");
		FAIL;
	} else
		CHECK;

	XFree((char*)chint);

	CHECKPASS(3);


	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion XAllocClassHint-2.(B)
 *   Reason: There is no known portable test method for this assertion
 * When insufficient memory is available, then a call to
 * XAllocClassHint returns NULL.
 */
static void
t002()
{
	report("There is no known portable test method for this assertion");
	UNTESTED;
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	t002, 2,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
