/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: allcwmhnts.m,v 1.7 92/06/11 17:27:21 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   XWMHints *
 *   XAllocWMHints()
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XAllocWMHints	1
char    *TestName = "XAllocWMHints";



int 	tet_thistest;

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XAllocWMHints-1.(A)
 * A call to XAllocWMHints allocates and returns a pointer to
 * a XWMHints structure, which can be freed with XFree, in
 * which each component is set to zero.
 */
static void
t001()
{
XWMHints	*hints;
int 	pass = 0, fail = 0;

	tpstartup();

	startcall(Dsp);
	if (isdeleted())
		return;
	hints = XAllocWMHints();
	endcall(Dsp);
	if (geterr() != Success) {
		report("Got %s, Expecting Success", errorname(geterr()));
		FAIL;
	}

	if(hints == (XWMHints *) NULL) {
		delete("XAllocWMHints returned NULL.");
		return;
	} else
		CHECK;

	if( hints->flags != 0L ) {
		report("The flags component of the XWMHints structure was not 0.");
		FAIL;
	} else
		CHECK;

	if( hints->input != (Bool) 0 ) {
		report("The input component of the XWMHints structure was not 0.");
		FAIL;
	} else
		CHECK;

	if( hints->initial_state != (int) 0 ) {
		report("The initial_state component of the XWMHints structure was not 0.");
		FAIL;
	} else
		CHECK;

	if( hints->icon_pixmap != (Pixmap) 0 ) {
		report("The icon_pixmap component of the XWMHints structure was not 0.");
		FAIL;
	} else
		CHECK;

	if( hints->icon_window != (Window) 0 ) {
		report("The icon_window component of the XWMHints structure was not 0.");
		FAIL;
	} else
		CHECK;

	if( hints->icon_x != (int) 0 ) {
		report("The icon_x component of the XWMHints structure was not 0.");
		FAIL;
	} else
		CHECK;

	if( hints->icon_y != (int) 0 ) {
		report("The icon_y component of the XWMHints structure was not 0.");
		FAIL;
	} else
		CHECK;

	if( hints->icon_mask != (Pixmap) 0 ) {
		report("The icon_mask component of the XWMHints structure was not 0.");
		FAIL;
	} else
		CHECK;

	if( hints->window_group != (XID) 0 ) {
		report("The window_group component of the XWMHints structure was not 0.");
		FAIL;
	} else
		CHECK;

	XFree((char*)hints);

	CHECKPASS(10);

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion XAllocWMHints-2.(B)
 *   Reason: There is no known portable test method for this assertion
 * When insufficient memory is available, then a call to
 * XAllocWMHints returns NULL.
 */
static void
t002()
{
	report("There is no known portable test method for this assertion");
	UNTESTED;
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	t002, 2,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
