/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: dstryimg.m,v 1.3 92/06/11 17:33:55 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   int
 *   XDestroyImage(ximage)
 *   XImage	*ximage;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XDestroyImage	1
char    *TestName = "XDestroyImage";

/*
 * Defines for different argument types
 */


/*
 * Arguments to the XDestroyImage function
 */
static XImage	*ximage;


static int 	ValueReturn;

int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	ximage = 0;
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XDestroyImage-1.(B)
 *   Reason: There is no known portable test method for this assertion
 * A call to XDestroyImage frees both the structure and image
 * data specified by the ximage argument.
 */
static void
t001()
{
int 	i;
int	bp;
static  int	fmat[2] = {XYPixmap, ZPixmap};
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();

	bp = BitmapPad(Dsp);

	for(i=0; i<20; i++) {

		ximage = XGetImage(Dsp, RootWindow(Dsp, 0), 0,0, 12,13, AllPlanes, fmat[ i%2 ]);
		if(ximage == (XImage *) NULL){
			delete("XGetImage() returned NULL.");
			return;
		} else
			if(i == 19)
				CHECK;
		
		XAddPixel(ximage, 1<<29 - 7);
		startcall(Dsp);
		if (isdeleted())
			return;
		ValueReturn = XDestroyImage(ximage);
		endcall(Dsp);
		if (geterr() != Success) {
			report("Got %s, Expecting Success", errorname(geterr()));
			FAIL;
		}

		ximage = XCreateImage(Dsp, DefaultVisual(Dsp, 0), 32, fmat [ 1 - i%2 ], 5, (char *) NULL, 13,23, 32, 0);

		if(ximage == (XImage *) NULL){
			delete("XCreateImage() returned NULL.");
			return;
		} else
			if(i == 19)
				CHECK;

		startcall(Dsp);
		if (isdeleted())
			return;
		ValueReturn = XDestroyImage(ximage);
		endcall(Dsp);
		if (geterr() != Success) {
			report("Got %s, Expecting Success", errorname(geterr()));
			FAIL;
		}

	} 

	CHECKUNTESTED(2);
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
