/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: unnrctwthr.m,v 1.7 92/06/11 17:43:38 rws Exp $
 * 
 */
/*
 * SYNOPSIS:
 *   
 *   XUnionRectWithRegion(rectangle, src_region, dest_region_return)
 *   XRectangle	*rectangle;
 *   Region		src_region;
 *   Region		dest_region_return;
 */

/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_XUnionRectWithRegion	1
char    *TestName = "XUnionRectWithRegion";

/*
 * Defines for different argument types
 */


/*
 * Arguments to the XUnionRectWithRegion function
 */
static XRectangle	*rectangle;
static Region		src_region;
static Region		dest_region_return;


int 	tet_thistest;

/*
 * Called at the beginning of each test purpose to reset the
 * arguments to their initial values
 */
static void
setargs()
{
	rectangle = 0;
	src_region = 0;
	dest_region_return = 0;
}

/*
 * Set the arguments to default values for error tests
 */
static void
seterrdef()
{
}

/*
 * Assertion XUnionRectWithRegion-1.(A)
 * A call to XUnionRectWithRegion computes the union of the
 * rectangle rectangle and the region src_region and stores the
 * result in dest_region_return.
 */
static void
t001()
{
static XRectangle	rect = { 7,9, 23,37 };
XRectangle		rrect;
Region 			R1;
int 	pass = 0, fail = 0;

	tpstartup();
	setargs();


	R1 = makeregion();
	rectangle = &rect;
	src_region = R1;
	dest_region_return = R1;
	startcall(Dsp);
	if (isdeleted())
		return;
	XUnionRectWithRegion(rectangle, src_region, dest_region_return);
	endcall(Dsp);
	if (geterr() != Success) {
		report("Got %s, Expecting Success", errorname(geterr()));
		FAIL;
	}

	XClipBox(R1, &rrect);

	if( (rect.x != rrect.x) || (rect.y != rrect.y) || (rect.width != rrect.width) || (rect.height != rrect.height)) {
		report("%s() set a rectangle x - %d y - %d width - %d height - %d",
			 TestName,
			 rrect.x, rrect.y, rrect.width, rrect.height);
		report("instead of x - %d y - %d width - %d height - %d.",
			 rect.x, rect.y, rect.width, rect.height);

		FAIL;
	} else
		PASS;
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
