/*
 *      SCCS:  @(#)  kysym.m Rel 1.11	    (5/12/92)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1991 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 * 
 */
/* $XConsortium: mcinclude.mc,v 1.2 92/06/29 19:41:37 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"Xlib.h"
#include	"Xutil.h"
#include	"Xresource.h"
#include	"tet_api.h"
#include	"xtestlib.h"
#include	"pixval.h"
/* $XConsortium: mcextern.mc,v 1.2 92/06/29 19:41:35 rws Exp $ */

extern	Display	*Dsp;
extern	Window	Win;

extern	Window	ErrdefWindow;
extern	Drawable ErrdefDrawable;
extern	GC		ErrdefGC;
extern	Colormap ErrdefColormap;
extern	Pixmap	ErrdefPixmap;
extern	Atom	ErrdefAtom;
extern	Cursor	ErrdefCursor;
extern	Font	ErrdefFont;


#define T_keysym	1
char    *TestName = "keysym";



int 	tet_thistest;

/*
 * Assertion keysym-1.(A)
 * When the header file <X11/keysym.h> is included, then the
 * symbols in the table which have code 1 are defined to have
 * the hexadecimal values given in the table.
 */
static void
t001()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysym1();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysym-2.(A)
 * When the header file <X11/keysym.h> is included, then the
 * symbols in the table which have code 2 are defined to have
 * the hexadecimal values given in the table.
 */
static void
t002()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysym2();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysym-3.(A)
 * When the header file <X11/keysym.h> is included, then the
 * symbols in the table which have code 3 are defined to have
 * the hexadecimal values given in the table.
 */
static void
t003()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysym3();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysym-4.(A)
 * When the header file <X11/keysym.h> is included, then the
 * symbols in the table which have code 4 are defined to have
 * the hexadecimal values given in the table.
 */
static void
t004()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysym4();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysym-5.(A)
 * When the header file <X11/keysym.h> is included, then the
 * symbols in the table which have code G are defined to have
 * the hexadecimal values given in the table.
 */
static void
t005()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymG();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysym-6.(A)
 * When the header file <X11/keysym.h> is included, then the
 * symbols in the table which have code M are defined to have
 * the hexadecimal values given in the table.
 */
static void
t006()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysymM();

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion keysym-7.(A)
 * When the header file <X11/keysym.h> is included, then the
 * symbols in the table are defined to have the hexadecimal
 * values given in the table.
 */
static void
t007()
{
int 	pass = 0, fail = 0;

	tpstartup();

	kysym0();
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	t002, 2,
	t003, 3,
	t004, 4,
	t005, 5,
	t006, 6,
	t007, 7,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = startup;
void	(*tet_cleanup)() = cleanup;
