/*
 * Copyright 1990, 1991 by the Massachusetts Institute of Technology and
 * UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the names of MIT and UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  MIT and UniSoft
 * make no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: opndsply.m,v 1.8 92/06/11 17:54:43 rws Exp $
 * 
 */
/* $XConsortium: mcxpinc.mc,v 1.2 92/06/29 19:42:05 rws Exp $ */

#include	<stdlib.h>
#include	"xtest.h"
#include	"tet_api.h"


#define T_OpenDisplay	1
char    *TestName = "OpenDisplay";



/* Touch test for OpenDisplay request */

/****************************************************************************
 * Copyright 1989 by Sequent Computer Systems, Inc., Portland, Oregon       *
 *                                                                          *
 *                                                                          *
 *                         All Rights Reserved                              *
 *                                                                          *
 * Permission to use, copy, modify, and distribute this software and its    *
 * documentation for any purpose and without fee is hereby granted,         *
 * provided that the above copyright notice appears in all copies and that  *
 * both that copyright notice and this permission notice appear in          *
 * supporting documentation, and that the name of Sequent not be used       *
 * in advertising or publicity pertaining to distribution or use of the     *
 * software without specific, written prior permission.                     *
 *                                                                          *
 * SEQUENT DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING *
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL *
 * SEQUENT BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR  *
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,      *
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,   *
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS      *
 * SOFTWARE.                                                                *
 ****************************************************************************/

#include "Xstlib.h"


#define CLIENT 0
static TestType test_type = SETUP;

/* 
   intent:	 send an OpenDisplay request to the server and check
                 that the server sent an OpenDisplay reply back
   input:	 
   output:	 none
   global input: 
   side effects: 
   methods:	 
*/

static
void
tester()
{
	int status = Create_Client_Tested(CLIENT, test_type);

	if(!status) {
		switch(test_type) {
		case OPEN_DISPLAY:
			Log_Err("Expected connection to fail, but it didn't");
			break;
		default:
			Log_Err("Expected connection not to fail, but it did");
			break;
		}
		Exit();
	}

	Exit_OK();
}

int 	tet_thistest;

/*
 * Assertion OpenDisplay-1.(A)
 * When a client sends a valid OpenDisplay protocol request to
 * the X server, then the X server sends back a valid
 * authorisation-accepted reply to the client.
 */
static void
t001()
{
int 	pass = 0, fail = 0;

	tpstartup();

	test_type = GOOD;

	/* Call a library function to exercise the test code */
	testfunc(tester);

	tpcleanup();
	pfcount(pass, fail);
}

/*
 * Assertion OpenDisplay-2.(B)
 *   Reason: There is no known portable test method for this assertion
 * When a client sends an invalid OpenDisplay protocol request
 * to the X server, in which the byte_order is not 0x42 or
 * 0x6C, then the X server does not send back a valid
 * authorisation-accepted reply to the client.
 */
static void
t002()
{
int 	pass = 0, fail = 0;

	tpstartup();

	test_type = OPEN_DISPLAY;

	/* Call a library function to exercise the test code */
	testfunc(tester);
	tpcleanup();
	pfcount(pass, fail);
}

/* End of Test Cases */


struct tet_testlist tet_testlist[] = {
	t001, 1,
	t002, 2,
	NULL, 0
};

int 	ntests = sizeof(tet_testlist)/sizeof(struct tet_testlist)-1;

void	(*tet_startup)() = protostartup;
void	(*tet_cleanup)() = protocleanup;
